﻿
Function ComRelease{
    param($obj);
    if ($obj -ne $null ){
        while([System.Runtime.InteropServices.Marshal]::ReleaseComObject($obj) -gt 0){}
    }
}


# Windows Update に必要な4つのインスタンスを用意する
$Searcher = New-Object -ComObject Microsoft.Update.Searcher  					
$UpdateColl = New-Object -ComObject Microsoft.Update.UpdateColl  				
$Session = New-Object -ComObject Microsoft.Update.Session  						
$Installer = New-Object -ComObject Microsoft.Update.Installer  

# Updateが必要なモジュールの一覧を取得する -> $UpdateColl
"更新モジュールの取得中…"
$Result = $Searcher.Search("Type='Software' AND IsInstalled = 0")
foreach ($module in $Result.Updates) {
	if ($module.AutoSelectOnWebSites -eq $true) {
		$module.Title
		$UpdateColl.Add($module) > $null
	}
}

if ($UpdateColl.Count -eq 0) {
	"更新が必要なモジュールはありません"
}
else {

	# 更新モジュールをダウンロードする
	"更新モジュールのダウンロード…"
	$Downloader = $Session.CreateUpdateDownloader()  
	$Downloader.Updates = $UpdateColl
	$Downloader.Download()

	# ダウンロードしたモジュールをインストールする
	"更新モジュールのインストール…"
	$Installer.Updates = $UpdateColl
	$res = $Installer.Install() 

}

"終了"
exit